"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.applyDocWrite = exports.applyFieldWrite = exports.ApplyDocWriteError = void 0;
const trimop_1 = require("trimop");
const data_1 = require("./data");
function ApplyDocWriteError(field) {
    return { field };
}
exports.ApplyDocWriteError = ApplyDocWriteError;
/**
 *
 * @param param0
 * @returns
 */
function applyFieldWrite({ field, writeField, }) {
    if (writeField._type === 'String') {
        return trimop_1.optionFold(field, () => trimop_1.Right(writeField), (field) => field._type === 'String' ? trimop_1.Right(writeField) : trimop_1.Left(ApplyDocWriteError(trimop_1.Some(field))));
    }
    if (writeField._type === 'Number') {
        return trimop_1.optionFold(field, () => trimop_1.Right(writeField), (field) => field._type === 'Number' ? trimop_1.Right(writeField) : trimop_1.Left(ApplyDocWriteError(trimop_1.Some(field))));
    }
    if (writeField._type === 'Image') {
        return trimop_1.optionFold(field, () => trimop_1.Right(writeField), (field) => field._type === 'Image' ? trimop_1.Right(writeField) : trimop_1.Left(ApplyDocWriteError(trimop_1.Some(field))));
    }
    if (writeField._type === 'Date') {
        return trimop_1.optionFold(field, () => trimop_1.Right(writeField), (field) => field._type === 'Date' ? trimop_1.Right(writeField) : trimop_1.Left(ApplyDocWriteError(trimop_1.Some(field))));
    }
    if (writeField._type === 'Ref') {
        return trimop_1.optionFold(field, () => trimop_1.Right(writeField), (field) => (field._type === 'Ref' ? trimop_1.Right(writeField) : trimop_1.Left(ApplyDocWriteError(trimop_1.Some(field)))));
    }
    if (writeField._type === 'CreationTime') {
        return trimop_1.optionFold(field, () => trimop_1.Right(data_1.DateField(new Date())), (field) => trimop_1.Left(ApplyDocWriteError(trimop_1.Some(field))));
    }
    if (writeField._type === 'Increment') {
        return trimop_1.optionFold(field, () => trimop_1.Right(data_1.NumberField(writeField.value)), (field) => field._type === 'Number'
            ? trimop_1.Right(data_1.NumberField(field.value + writeField.value))
            : trimop_1.Left(ApplyDocWriteError(trimop_1.Some(field))));
    }
    // writeField._type === 'RefUpdate'
    return trimop_1.optionFold(field, () => trimop_1.Left(ApplyDocWriteError(trimop_1.None())), (field) => {
        return field._type !== 'Ref'
            ? trimop_1.Left(ApplyDocWriteError(trimop_1.Some(field)))
            : trimop_1.eitherMapRight(
            // eslint-disable-next-line no-use-before-define
            applyDocWrite({ doc: trimop_1.Some(field.snapshot.doc), writeDoc: writeField.doc }), (newDoc) => trimop_1.Right(data_1.RefField({
                doc: newDoc,
                id: field.snapshot.id,
            })));
    });
}
exports.applyFieldWrite = applyFieldWrite;
function applyDocWrite({ doc, writeDoc, }) {
    const docc = trimop_1.optionFold(doc, () => ({}), (value) => value);
    return trimop_1.eitherArrayReduce(Object.entries(writeDoc), trimop_1.Right(docc), (acc, [fieldName, writeField]) => trimop_1.eitherMapRight(applyFieldWrite({ field: trimop_1.optionFromNullable(docc[fieldName]), writeField }), (field) => trimop_1.Right(Object.assign(Object.assign({}, acc), { [fieldName]: field }))));
}
exports.applyDocWrite = applyDocWrite;
//# sourceMappingURL=apply-doc-write.js.map