"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.isFieldEqual = void 0;
const trimop_1 = require("trimop");
function isFieldEqual(f1, f2) {
    if (f1._type === 'Date') {
        return trimop_1.optionFold(f2, () => false, (f2) => f2._type === 'Date' && f1.value.getTime() === f2.value.getTime());
    }
    if (f1._type === 'Number') {
        return trimop_1.optionFold(f2, () => false, (f2) => f2._type === 'Number' && f1.value === f2.value);
    }
    if (f1._type === 'String') {
        return trimop_1.optionFold(f2, () => false, (f2) => f2._type === 'String' && f1.value === f2.value);
    }
    if (f1._type === 'Image') {
        return trimop_1.optionFold(f2, () => false, (f2) => f2._type === 'Image' && f2.value.url === f1.value.url);
    }
    // f1._type === 'Ref'
    return trimop_1.optionFold(f2, () => false, (f2) => f2._type === 'Ref' &&
        f1.snapshot.id === f2.snapshot.id &&
        Object.keys(f1.snapshot.doc).length === Object.keys(f2.snapshot.doc).length &&
        Object.entries(f1.snapshot.doc).every(([field1ChildName, field1Child]) => isFieldEqual(field1Child, trimop_1.optionFromNullable(f2.snapshot.doc[field1ChildName]))));
}
exports.isFieldEqual = isFieldEqual;
//# sourceMappingURL=is-field-equal.js.map