import { Dict } from 'trimop';
export declare type SyncedFields = Dict<SyncedFields | true>;
export declare type ColRefer = {
    readonly colName: string;
    readonly fields: readonly {
        readonly name: string;
        readonly syncedFields: SyncedFields;
    }[];
    readonly thisColRefers: readonly ColRefer[];
};
export declare type CountFieldSpec = {
    readonly _type: 'Count';
    readonly countedCol: string;
    readonly groupByRef: string;
};
export declare type CreationTimeFieldSpec = {
    readonly _type: 'CreationTime';
};
export declare type ImageFieldSpec = {
    readonly _type: 'Image';
};
export declare type RefFieldSpec = {
    readonly _type: 'Ref';
    readonly isOwner: boolean;
    readonly refedCol: string;
    readonly syncedFields: SyncedFields;
    readonly thisColRefers: readonly ColRefer[];
};
export declare type StringFieldSpec = {
    readonly _type: 'String';
};
export declare type FieldSpec = CreationTimeFieldSpec | ImageFieldSpec | RefFieldSpec | StringFieldSpec | CountFieldSpec;
export declare type Spec = Dict<Dict<FieldSpec>>;
//# sourceMappingURL=spec.d.ts.map