var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
import { eitherArrayReduce, eitherMapRight, Left, None, optionFold, optionFromNullable, Right, Some, } from 'trimop';
import { DateField, NumberField, RefField } from './data';
export function ApplyDocWriteError(field) {
    return { field: field };
}
/**
 *
 * @param param0
 * @returns
 */
export function applyFieldWrite(_a) {
    var field = _a.field, writeField = _a.writeField;
    if (writeField._type === 'String') {
        return optionFold(field, function () { return Right(writeField); }, function (field) {
            return field._type === 'String' ? Right(writeField) : Left(ApplyDocWriteError(Some(field)));
        });
    }
    if (writeField._type === 'Number') {
        return optionFold(field, function () { return Right(writeField); }, function (field) {
            return field._type === 'Number' ? Right(writeField) : Left(ApplyDocWriteError(Some(field)));
        });
    }
    if (writeField._type === 'Image') {
        return optionFold(field, function () { return Right(writeField); }, function (field) {
            return field._type === 'Image' ? Right(writeField) : Left(ApplyDocWriteError(Some(field)));
        });
    }
    if (writeField._type === 'Date') {
        return optionFold(field, function () { return Right(writeField); }, function (field) {
            return field._type === 'Date' ? Right(writeField) : Left(ApplyDocWriteError(Some(field)));
        });
    }
    if (writeField._type === 'Ref') {
        return optionFold(field, function () { return Right(writeField); }, function (field) { return (field._type === 'Ref' ? Right(writeField) : Left(ApplyDocWriteError(Some(field)))); });
    }
    if (writeField._type === 'CreationTime') {
        return optionFold(field, function () { return Right(DateField(new Date())); }, function (field) { return Left(ApplyDocWriteError(Some(field))); });
    }
    if (writeField._type === 'Increment') {
        return optionFold(field, function () { return Right(NumberField(writeField.value)); }, function (field) {
            return field._type === 'Number'
                ? Right(NumberField(field.value + writeField.value))
                : Left(ApplyDocWriteError(Some(field)));
        });
    }
    // writeField._type === 'RefUpdate'
    return optionFold(field, function () { return Left(ApplyDocWriteError(None())); }, function (field) {
        return field._type !== 'Ref'
            ? Left(ApplyDocWriteError(Some(field)))
            : eitherMapRight(
            // eslint-disable-next-line no-use-before-define
            applyDocWrite({ doc: Some(field.snapshot.doc), writeDoc: writeField.doc }), function (newDoc) {
                return Right(RefField({
                    doc: newDoc,
                    id: field.snapshot.id,
                }));
            });
    });
}
export function applyDocWrite(_a) {
    var doc = _a.doc, writeDoc = _a.writeDoc;
    var docc = optionFold(doc, function () { return ({}); }, function (value) { return value; });
    return eitherArrayReduce(Object.entries(writeDoc), Right(docc), function (acc, _a) {
        var fieldName = _a[0], writeField = _a[1];
        return eitherMapRight(applyFieldWrite({ field: optionFromNullable(docc[fieldName]), writeField: writeField }), function (field) {
            var _a;
            return Right(__assign(__assign({}, acc), (_a = {}, _a[fieldName] = field, _a)));
        });
    });
}
//# sourceMappingURL=apply-doc-write.js.map