import { Dict } from 'trimop';
/**
 * Field
 */
export declare type BaseField = {
    readonly _type: string;
};
/**
 *StringField
 */
export declare function StringField(value: string): StringField;
export declare type StringField = {
    readonly _type: 'String';
    readonly value: string;
};
/**
 *NumberField
 */
export declare function NumberField(value: number): NumberField;
export declare type NumberField = {
    readonly _type: 'Number';
    readonly value: number;
};
/**
 *DateField
 */
export declare function DateField(value: Date): DateField;
export declare type DateField = {
    readonly _type: 'Date';
    readonly value: Date;
};
/**
 *RefField
 */
export declare function RefField(snapshot: DocSnapshot): RefField;
export declare type RefField = {
    readonly _type: 'Ref';
    readonly snapshot: DocSnapshot;
};
/**
 * RefUpdateField
 */
export declare function RefUpdateField(doc: WriteDoc): RefUpdateField;
export declare type RefUpdateField = {
    readonly _type: 'RefUpdate';
    readonly doc: WriteDoc;
};
/**
 *ImageField
 */
export declare type ImageFieldValue = {
    readonly url: string;
};
export declare function ImageField(value: ImageFieldValue): ImageField;
export declare type ImageField = {
    readonly _type: 'Image';
    readonly value: ImageFieldValue;
};
/**
 *CreationTimeField
 */
export declare function CreationTimeField(): CreationTimeField;
export declare type CreationTimeField = {
    readonly _type: 'CreationTime';
};
/**
 *CreationTimeField
 */
export declare function IncrementField(value: number): IncrementField;
export declare type IncrementField = {
    readonly _type: 'Increment';
    readonly value: number;
};
/**
 * Doc
 */
export declare type DocKey = {
    readonly col: string;
    readonly id: string;
};
export declare type Field = BaseField & (StringField | NumberField | DateField | ImageField | RefField);
export declare type WriteField = BaseField & (StringField | NumberField | DateField | ImageField | CreationTimeField | IncrementField | RefField | RefUpdateField);
export declare type Doc = Dict<Field>;
export declare type DocSnapshot = {
    readonly doc: Doc;
    readonly id: string;
};
export declare type WriteDoc = Dict<WriteField>;
export declare type WriteDocSnapshot = {
    readonly doc: WriteDoc;
    readonly id: string;
};
//# sourceMappingURL=data.d.ts.map