import { Either, Option } from 'trimop';
import { Doc, Field } from './data';
import { SyncedFields } from './spec';
/**
 * FilterSyncedFieldInvalidFieldTypeError
 */
export declare type FilterSyncedFieldsError = {
    readonly field: Field;
};
export declare function FilterSyncedFieldsError(field: Field): FilterSyncedFieldsError;
/**
 * Filter synced fields.
 * @param doc to be filtered
 * @param syncedFields
 * @returns synced fields if exists, undefined otherwise.
 */
export declare function filterSyncedFields({ doc, syncedFields, }: {
    readonly doc: Doc;
    readonly syncedFields: SyncedFields;
}): Either<FilterSyncedFieldsError, Option<Doc>>;
//# sourceMappingURL=filter-synced-fields.d.ts.map